unitsize(30);
import graph;

real A = 1;
real v0 = -0.25;
real x0 = 1.0;
real w = 2.0;
real P = 2*pi/w;
real a(real t) {return A*sin(w*t);} 
real v(real t) {return v0 + (A/w)*(1-cos(w*t));} 
real x(real t) {return x0 + (v0 + A/w)*t - (A/(w*w))*sin(w*t);} 



real T = 2.1*P;
draw(graph(a,0,T,operator ..),heavyred);
draw(graph(v,0,T,operator ..),blue);
draw(graph(x,0,T,operator ..),black);

xlimits(0,T);
ylimits(-1.2,2.8);

yaxis("",LeftRight); 
yequals(0,linetype("2 2")+heavyred); 
yequals(x0,linetype("2 2")); 
yequals(v0,linetype("2 2")+blue); 

xaxis("$t$",BottomTop); 
xequals(P,linetype("4 6")+heavygreen); 
xequals(2*P,linetype("4 6")+heavygreen); 

real tm = 0.32*T;
label("$a$",(tm,a(tm)),W,heavyred);
label("$v$",(tm,v(tm)),E,blue);
label("$x$",(tm,x(tm)),N);
label("$t = \frac{2\pi}{\omega}$",(P,2.8),SE,heavygreen);

arrow("$x_0$",(0.06*T,x0),N,12,Margin(0,0));
arrow("$v_0$",(0.06*T,v0),S,12,blue,Margin(0,0));