import three;

real R = 80;

triple viewer= (400,100,200);
currentprojection = perspective(viewer);
//currentprojection = orthographic(viewer);

real phi = 20;

picture pic;
triple O = (0,0,0);
triple yp = rotate(phi,Z)*(R*Y);
triple xp = rotate(phi,Z)*(R*X);

draw(pic,scale3(R)*unitcircle3);
draw(pic,O--R*X,dashed);
draw(pic,O--R*Y,dashed);
draw(pic,O--xp);
draw(pic,O--yp);
draw(pic,O--R*Z);
label(pic,"$z$",R*Z,N);
label(pic,"$x$",R*X,S);
label(pic,"$x'$",xp,S);
label(pic,"$y$",R*Y,E);
label(pic,"$y'$",yp,E);
draw(pic,"$\phi$", arc(O, 0.7*R, 90, 0, 90, phi),EndArrow3);

attach(pic.fit());
erase(pic);

//------------------------------------------------------------

real theta = 35;

draw(pic,scale3(R)*unitcircle3,dashed);
draw(pic,O--R*X,dashed);
draw(pic,O--R*Y,dashed);
draw(pic,O--R*Z,dashed);
draw(pic,-1.3*xp--1.3*xp,linetype("2 2"));
draw(pic,O--xp);
yp = rotate(theta,xp)*yp;
draw(pic,O--yp);
triple zp = rotate(theta,xp)*(R*Z);
draw(pic,O--zp);
label(pic,"$z$",R*Z,N);
label(pic,"$z'$",zp,N);
label(pic,"$x$",R*X,S);
label(pic,"$x'$",xp,SE);
label(pic,"$y$",R*Y,E);
label(pic,"$y'$",yp,E);
draw(pic,"$\phi$", arc(O, 0.7*R, 90, 0, 90, phi));
draw(pic,"$\theta$", arc(O, 0.7*R, 0, 0, theta, phi-90),EndArrow3);
draw(pic,rotate(theta,xp)*scale3(R)*unitcircle3);

attach(pic.fit(),180*SW);
erase(pic);

//------------------------------------------------------------

real psi = 20;

draw(pic,scale3(R)*unitcircle3,dashed);
draw(pic,O--R*X,dashed);
draw(pic,O--R*Y,dashed);
draw(pic,O--R*Z,dashed);
draw(pic,-1.3*xp--1.3*xp,linetype("2 2"));
//draw(pic,O--yp,dashed);
yp = rotate(psi,zp)*yp;
triple nodes = xp;
xp = rotate(psi,zp)*xp;
draw(pic,O--yp);
draw(pic,O--xp);
draw(pic,O--zp);
label(pic,"$z$",R*Z,N);
label(pic,"$z'$",zp,N);
label(pic,"$x$",R*X,S);
label(pic,"$x'$",xp,S);
label(pic,"$y'$",yp,NE);
label(pic,"$y$",R*Y,E);
label(pic,"ligne des noeuds",1.1*nodes,2*SE);
draw(pic,"$\phi$", arc(O, 0.7*R, 90, 0, 90, phi));
draw(pic,"$\theta$", arc(O, 0.7*R, 0, 0, theta, phi-90));
draw(pic,"$\psi$", arc(O, 0.7*nodes, 0.7*xp),EndArrow3);
//draw(pic,rotate(theta,nodes)*scale3(R)*unitdisk,white+opacity(10));
draw(pic,rotate(theta,nodes)*scale3(R)*unitcircle3);


attach(pic.fit(),180*SE);



